#!/usr/bin/perl -w
#
# DF SiteMonitor example API 
# www.dfservice.com 2007
# VER="1.01";
#
# -            ($URL),
#     ()   .
#   -    :
# 1  - -       .
# 2  - -       ( )
# 3  -   -
#

# Settings
$SM_SCRIPT="smcrn.cgi";   #
$SM_PWD="df";      # administrate password for  SiteMonitor
$SM_GROUP="sm_io";
$OUT_SCRIPT="perl ./sm_io.cgi";   #    

$IN_URLS_FILE="urls.txt";
$OUT_URLS_FILE_OK="urls_ok.txt";
$OUT_URLS_FILE_FAIL="urls_fail.txt";
$OUT_URLS_FILE_ERR="urls_err.txt";

#      
$LINK="<a href=http://mydomain.com/test.html>test</a>";

#   
@P=($LINK      ,                         "LINK not found",     #    
    "<body[~*~]".$LINK."[~*~]</body>",   "LINK not in body");  #     body
		  
#   
@B=("<body[~?+'<!--',-'-->'~]".$LINK,              "<!-- LINK -->",  #       <!-- -->     body 
    "<body[~?+'<noindex>',-'</noindex>'~]".$LINK,  "<noindex> LINK </noindex>"  #       <noindex> </noindex>     body
 	 );    
	 

$web=0;	 
if( $ENV{'HTTP_HOST'} ) { 
  print "Content-type: text/html\n\n<pre>";
	$web=1;
	if($#ARGV<0) { 
    $ARGV[0]="checkfile"; 
  }
}

print "Command not found!\n" if($#ARGV<0);


if($ARGV[0] eq "checkfile") { #       
 
   if( $#ARGV>0 ) {
     $IN_URLS_FILE=$ARGV[1];
  	 $SM_GROUP=$IN_URLS_FILE;
   }
   if( !-e($IN_URLS_FILE) ) {
	   print "Urls file $IN_URLS_FILE not found!\n";
	 }
	 
	 unlink($OUT_URLS_FILE_OK)   if( -e($OUT_URLS_FILE_OK) );  #     ,   
   unlink($OUT_URLS_FILE_FAIL) if( -e($OUT_URLS_FILE_FAIL) );  #     ,   
   unlink($OUT_URLS_FILE_ERR)  if( -e($OUT_URLS_FILE_ERR) );  #     ,   	 

   if( $web ) {  # for other web directory
     $ENV{'HTTP_HOST'}="";
     $ENV{'SCRIPT_NAME'}="";
   }
   $ENV{'ADMIN_PWD'}=$SM_PWD;
	  
   my $i;
   open(SM, "|./$SM_SCRIPT writegroup $SM_GROUP") || print "Error $!";
     print SM "action=set\n";  #  
  	 print SM "checktime=-1\n";  #  1 
 	   print SM "inftype=1\n";  #   
   	 print SM "inform=$OUT_SCRIPT report $SM_GROUP\n";  #    	 	 	 
  	 print SM "infuptime=1\n";  #    c uptime
   	 print SM "inffndban=1\n";  #     
     print SM "inffndpres=1\n";  #     
     print SM "inffndpres=1\n";  #     
     print SM "delete_after_check=1\n"; #  	     (   0)

    print "Required content:\n";			 
		 for($i=0; $i<$#P; $i+=2) {
       $cont=$P[$i];		 
     	 print SM "prescontent=".length($cont)."\n$cont\n";
 		  print $web?&to_html("$cont")."\n":"$cont\n";			 		 
		 }

    print "\nForbidden content:\n";		 
		 for($i=0; $i<$#B; $i+=2) {
       $cont=$B[$i];		 
     	 print SM "bancontent=".length($cont)."\n$cont\n";
    	print $web?&to_html("$cont")."\n":"$cont\n";			 			 		 
		 }

    print "\nURLs:\n";		 
     open(UF, "<$IN_URLS_FILE") || print "Error: $!";   #       
       while( <UF> )    {
			   $URL=$_;
			   chomp($URL);				 
       	 print SM "url=$URL\n";    #    
			   print SM "chkpres=1\n";   #    
				 print SM "chkban=1\n";    #     
	    	print "$URL\n"; 
       }
     close(UF);
   close(SM);		
   print "OK";
  
exit(0);	 
}	 

if($ARGV[0] eq "report") { #     

     my (@R, $ret, $np, $nb, $uptime, $fndban, $fndpres, $httpcode);
      while( <STDIN> )    {
			  chomp($_);
				@R=(); 
      	($Url, $Status, @R)=split(" ",$_);
											
				$uptime=($Status&1)?1:0;   # uptime 
				$fndban=($Status&2)?1:0;   #   
				$fndpres=($Status&4)?1:0;	 #     			
        
				$rem="";
        foreach $rr (@R) { #  
				  if($rr=~'c=') {
					  $httpcode=(split("c=",$rr))[1];
					}
				  if($rr=~'f=') {
					  $nb=(split("f=",$rr))[1];
						$rem.=$B[$nb+1];
					}	
				  if($rr=~'p=') {
					  $np=(split("p=",$rr))[1];
						$rem.=$P[$np+1];						
					}	
        }
#				if(!$rem && $uptime) {
#				  $rem="OK";
#				}
      }
			
			if($uptime && ($fndban || !$fndpres)) {
          open(OF, ">>$OUT_URLS_FILE_FAIL") || print "Error !m=$!";	
#					flock (OF, 2)								
    			print OF "$Url - $rem\n";
		  	  close(OF);
			} else {
				  my $ofile;
				  if($uptime) {  # OK
            $ofile=$OUT_URLS_FILE_OK;
					} else {  # Down Site
            $ofile=$OUT_URLS_FILE_ERR; 
					}
          open(OF, ">>$ofile") || print "Error !m=$!";	
#					flock (OF, 2) 			
    			print OF "$Url\n";
		  	  close(OF);
			}			
exit(0);    
}


sub to_html {
	my ($str) = @_;
	$str =~ s/&/&amp;/g;
	$str =~ s/\"/&quot;/g;
	$str =~ s/</&lt;/g;
	$str =~ s/>/&gt;/g;
#	$str =~ s/}/&rbr;/g;
#	$str =~ s/{/&lbr;/g;

return $str;
}